//+------------------------------------------------------------------+
//|                                      mtf-parabolic-system-v2.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"




#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_maximum 2.0
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
extern int thickness = 1;
extern int tmf_1 = 15;
extern int tmf_2 = 60;
extern int tmf_3 = 240;
//extern bool alertEnabled = false;
extern bool debugOn = false;
static double alertBar;
int i, yy, y15m, y4h, y1h;
double PSAR;
double step = 0.02;
double maximum = 0.2;
double long[];
double short[];
static bool tmf_1_up, tmf_2_up, tmf_3_up, tmf_1_down, tmf_2_down, tmf_3_down;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0, long);
   SetIndexStyle(0, DRAW_ARROW, EMPTY, thickness);
   SetIndexArrow(0, 117);
   SetIndexEmptyValue(0, 0.0);
   SetIndexBuffer(1, short);
   SetIndexStyle(1, DRAW_ARROW, EMPTY, thickness);
   SetIndexArrow(1, 117);
   SetIndexEmptyValue(1, 0.0);
   IndicatorShortName("Triple Screen Parabolic Sar");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   int totBars, tmf_1_shift, tmf_2_shift, tmf_3_shift;
   double tmf_1_psar, tmf_2_psar, tmp_3_psar;
   
   
   if (counted_bars < 0) counted_bars = 0;
   if (counted_bars > 0) counted_bars--;
   totBars = Bars - counted_bars;
   
   datetime TimeArray_4H[], TimeArray_1H[], TimeArray_15M[];
   
   for (i=0, y15m=0, y1h=0, y4h=0; i < 1000; i++) {
      //do some stuff here
      if (Time[i]<TimeArray_15M[y15m]) y15m++;
      if (Time[i]<TimeArray_1H[y1h])   y1h++;
      if (Time[i]<TimeArray_4H[y4h])   y4h++;
      
      for (int tf = 1; tf <= 3; tf++)
      {
         int prd;
         switch (tf)
         {
            case 1: prd = tmf_1;  yy = y15m;  break;
            case 2: prd = tmf_2;  yy = y1h;   break;
            case 3: prd = tmf_3;  yy = y4h;   break;
         }
         
         PSAR = iSAR(NULL, prd, step, maximum, yy);

         double dUp = EMPTY_VALUE;
         double dDn = EMPTY_VALUE;
         
         if (PSAR < iLow(NULL, prd, yy) ) dUp = 1; else dDn = 1;
         
         if (tmf_1_up == 1 && tmf_2_up == 1 && tmf_3_up == 1) {
            long[i] = 1;
         }
         
         if (tmf_1_down == 1 && tmf_2_down == 1 && tmf_3_down == 1) {
            short[i] = 1;
         }
         
         switch (tf)
         {
            case 1: 
               if (dUp == 1) tmf_1_up = 1; tmf_1_down = 0; 
               if (dDn == 1) tmf_1_up = 0; tmf_1_down = 1;
               break;
           case 2: 
               if (dUp == 1) tmf_2_up = 1; tmf_2_down = 0; 
               if (dDn == 1) tmf_2_up = 0; tmf_2_down = 1;
               break;   
          case 3: 
               if (dUp == 1) tmf_3_up = 1; tmf_3_down = 0; 
               if (dDn == 1) tmf_3_up = 0; tmf_3_down = 1;
               break;    
         }
         
      }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+